/*-----Ȩ-----
 *     ׵ӹҡÿø 
 *     վhttp://www.amy-studio.com
 *     Աhttp://amy-studio.taobao.com
 *     QQ䣩amy-studio@qq.com
 *-----ļϢ-----
 *     ļƣAmy_S_seg7x8_avalon_interface.v
 *     ޸ڣ3.20, 2010
 *     Seg7Avalonӿļ
 *------------------
 *     ߣǷ
 *     ڣ3.20, 2009
 *     汾1.0
 *     ԭʼ汾
 *------------------
 *     ޸ߣ
 *     ޸ڣ
 *     汾
 *     
 *-------------------
 */

module Amy_S_seg7x8_avalon_interface(
  // Clcok Input
  input         csi_clk,
  input         csi_reset_n,
  // Avalon-MM Slave
  input  [1:0]  avs_address,
  input         avs_write,
  input  [31:0] avs_writedata,
  // Conduit End 
  // lcd12864 interface
  output [7:0]  coe_seg,
  output [2:0]  coe_sel 
);

//++++++++++++++++++++++++++++++++++++++
// seg7x8_driveģ ʼ
//++++++++++++++++++++++++++++++++++++++
reg [7:0]  seg7x8_turn_off_r;
reg [7:0]  seg7x8_dp_r;
reg [31:0] seg7x8_data_r;

seg7x8_drive u0(
  .i_clk            (csi_clk),
  .i_rst_n          (csi_reset_n),
  
  .i_turn_off       (seg7x8_turn_off_r),// Ϩλ[2]
  .i_dp             (seg7x8_dp_r),      // Сλ[2]
  .i_data           (seg7x8_data_r),    // [16]
  
  .o_seg            (coe_seg),
  .o_sel            (coe_sel)
);
//--------------------------------------
// seg7x8_driveģ 
//--------------------------------------


//++++++++++++++++++++++++++++++++++++++
// д ʼ
//++++++++++++++++++++++++++++++++++++++
always@(posedge csi_clk, negedge csi_reset_n)
begin
  if (!csi_reset_n)
  begin 
    seg7x8_turn_off_r <= 8'b1111_1111;
    seg7x8_dp_r       <= 8'b0;
    seg7x8_data_r     <= 32'h0;
  end
  else if (avs_write)
  begin
    case (avs_address)
      0: seg7x8_turn_off_r <= avs_writedata[7:0];
      1: seg7x8_dp_r       <= avs_writedata[7:0];
      2: seg7x8_data_r     <= avs_writedata[31:0];
    endcase
  end
end
//--------------------------------------
// д 
//--------------------------------------

endmodule
