/*-----Ȩ-----
 *     ׵ӹҡÿø 
 *     վhttp://www.amy-studio.com
 *     Աhttp://amy-studio.taobao.com
 *     QQ䣩amy-studio@qq.com
 *-----ļϢ-----
 *     ļƣAmy_S_n5110_lcd_avalon_interface.v
 *     ޸ڣ1.26, 2010
 *     Nokia 5110 LCD Avalon Interface
 *------------------
 *     ߣǷ
 *     ڣ10.28, 2009
 *     汾1.0
 *     ԭʼ汾
 *------------------
 *     ޸ߣǷ
 *     ޸ڣ1.26, 2010
 *     汾1.2
 *     ȥHALΪ9.1֧ûHAL
 *-------------------
 */

module Amy_S_n5110_lcd_avalon_interface(
  // Clcok Input
  input         csi_clk,
  input         csi_reset_n,
  // Avalon-MM Slave
  input         avs_chipselect,
  input [2:0]   avs_address,
  input         avs_write,
  input [31:0]  avs_writedata,
  // Conduit End 
  // ip_n5110 outputs
  output reg    coe_ce,
  output reg    coe_clk, 
  output reg    coe_dc,
  output reg    coe_din,
  output reg    coe_rst  
);

// write to ip_n5510 form NiosII cpu
always@(posedge csi_clk, negedge csi_reset_n)
begin
  if (!csi_reset_n)
  begin 
    coe_ce  <= 1'b0;
    coe_clk <= 1'b0;
    coe_dc  <= 1'b0;
    coe_din <= 1'b0;
    coe_rst <= 1'b0;
  end
  else if (avs_chipselect & avs_write)
  begin
    case (avs_address)
      0: coe_ce   <= avs_writedata[0];
      1: coe_clk  <= avs_writedata[0];
      2: coe_dc   <= avs_writedata[0];
      3: coe_din  <= avs_writedata[0];
      4: coe_rst  <= avs_writedata[0];
    endcase
  end
end

endmodule
